Index: python/GribTools.py
===================================================================
--- python/GribTools.py	(revision efdb01a8ac2d5cef85c651177aa18ac69dd660db)
+++ python/GribTools.py	(revision 991df6ad0a703d97e1e192a0a6106e1d9ba47e8e)
@@ -3,46 +3,50 @@
 #************************************************************************
 # TODO AP
-#AP
 # - GribTools name möglicherweise etwas verwirrend.
 # - change self.filename in self.filenames!!!
-# - add file description
 # - bis auf --init-- und index wird keine Funktion verwendet!?
 #************************************************************************
-"""
-@Author: Anne Fouilloux (University of Oslo)
-
-@Date: July 2014
-
-@ChangeHistory:
-   February 2018 - Anne Philipp (University of Vienna):
-        - applied PEP8 style guide
-        - added documentation
-        - changed some naming
-
-@License:
-    (C) Copyright 2014-2018.
-
-    This software is licensed under the terms of the Apache Licence Version 2.0
-    which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
-
-@Requirements:
-    - A standard python 2.6 or 2.7 installation
-    - dateutils
-    - ECMWF specific packages, all available from https://software.ecmwf.int/
-        ECMWF WebMARS, gribAPI with python enabled, emoslib and
-        ecaccess web toolkit
-
-@Description:
-    Further documentation may be obtained from www.flexpart.eu.
-
-    ...
-"""
+#*******************************************************************************
+# @Author: Anne Fouilloux (University of Oslo)
+#
+# @Date: July 2014
+#
+# @Change History:
+#   February 2018 - Anne Philipp (University of Vienna):
+#        - applied PEP8 style guide
+#        - added documentation
+#        - changed some naming
+#
+# @License:
+#    (C) Copyright 2014-2018.
+#
+#    This software is licensed under the terms of the Apache Licence Version 2.0
+#    which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
+#
+# @Class Description:
+#    The GRIB API provides all necessary tools to work directly with the
+#    grib files. Nevertheless, the GRIB API tools are very basic and are in
+#    direct connection with the grib files. This class provides some higher
+#    functions which apply a set of GRIB API tools together in the respective
+#    context. So, the class initially contains a list of grib files (their
+#    names) and the using program then applies the methods directly on the
+#    class objects without having to think about how the actual GRIB API
+#    tools have to be arranged.
+#
+# @Class Content:
+#    - __init__
+#    - getkeys
+#    - setkeys
+#    - copy
+#    - index
+#
+#*******************************************************************************
+
 # ------------------------------------------------------------------------------
 # MODULES
 # ------------------------------------------------------------------------------
+import os
 from gribapi import *
-import traceback
-import sys
-import os
+
 # ------------------------------------------------------------------------------
 # CLASS
Index: python/MARSretrieval.py
===================================================================
--- python/MARSretrieval.py	(revision efdb01a8ac2d5cef85c651177aa18ac69dd660db)
+++ python/MARSretrieval.py	(revision 991df6ad0a703d97e1e192a0a6106e1d9ba47e8e)
@@ -3,9 +3,44 @@
 #************************************************************************
 # TODO AP
-#AP
-# -
 # -
 #************************************************************************
-## ------------------------------------------------------------------------------
+#*******************************************************************************
+# @Author: Anne Fouilloux (University of Oslo)
+#
+# @Date: October 2014
+#
+# @Change History:
+#
+#   November 2015 - Leopold Haimberger (University of Vienna):
+#        - optimized displayInfo
+#        - optimized dataRetrieve and seperate between python and shell
+#          script call
+#
+#   February 2018 - Anne Philipp (University of Vienna):
+#        - applied PEP8 style guide
+#        - added documentation
+#        - applied some minor modifications in programming style/structure
+#
+# @License:
+#    (C) Copyright 2015-2018.
+#
+#    This software is licensed under the terms of the Apache Licence Version 2.0
+#    which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
+#
+# @Class Description:
+#    A MARS revtrieval has a specific syntax with a selection of keywords and
+#    their corresponding values. This class provides the necessary functions
+#    by displaying the selected parameters and their values and the actual
+#    retrievement of the data through a mars request or a Python web api
+#    interface. The initialization already expects all the keyword values.
+#
+# @Class Content:
+#    - __init__
+#    - displayInfo
+#    - dataRetrieve
+#
+#*******************************************************************************
+
+# ------------------------------------------------------------------------------
 # MODULES
 # ------------------------------------------------------------------------------
@@ -18,5 +53,5 @@
 except ImportError:
     ecapi = False
-#from gribapi import *
+
 # ------------------------------------------------------------------------------
 # CLASS
Index: python/Tools.py
===================================================================
--- python/Tools.py	(revision efdb01a8ac2d5cef85c651177aa18ac69dd660db)
+++ python/Tools.py	(revision 991df6ad0a703d97e1e192a0a6106e1d9ba47e8e)
@@ -3,21 +3,65 @@
 #************************************************************************
 # TODO AP
-#AP
-# -
+# - check myerror
+# - check normalexit
+# - check getListAsString
+# - seperate args and control interpretation
 #************************************************************************
-"""
-
-"""
+#*******************************************************************************
+# @Author: Anne Philipp (University of Vienna)
+#
+# @Date: May 2018
+#
+# @Change History:
+#    October 2014 - Anne Fouilloux (University of Oslo)
+#        - created functions silentremove and product (taken from ECMWF)
+#
+#    November 2015 - Leopold Haimberger (University of Vienna)
+#        - created functions: interpret_args_and_control, cleanup
+#          myerror, normalexit, init128, toparamId
+#
+#    April 2018 - Anne Philipp (University of Vienna):
+#        - applied PEP8 style guide
+#        - added documentation
+#        - moved all functions from file FlexpartTools to this file Tools
+#        - added function getListAsString
+#
+# @License:
+#    (C) Copyright 2014-2018.
+#
+#    This software is licensed under the terms of the Apache Licence Version 2.0
+#    which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
+#
+# @Modul Description:
+#    This module contains a couple of helpful functions which are
+#    used in different places in flex_extract.
+#
+# @Module Content:
+#    - interpret_args_and_control
+#    - cleanup
+#    - myerror
+#    - normalexit
+#    - product
+#    - silentremove
+#    - init128
+#    - toparamId
+#    - getListAsString
+#
+#*******************************************************************************
+
 # ------------------------------------------------------------------------------
 # MODULES
 # ------------------------------------------------------------------------------
-from argparse import ArgumentParser, ArgumentDefaultsHelpFormatter
 import os
 import errno
 import sys
 import glob
+import traceback
 from numpy import *
 from gribapi import *
-import Control
+from argparse import ArgumentParser, ArgumentDefaultsHelpFormatter
+
+# software specific class from flex_extract
+from ControlFile import ControlFile
 
 # ------------------------------------------------------------------------------
@@ -28,5 +72,5 @@
     '''
     @Description:
-        Assigns the command line arguments and reads control file
+        Assigns the command line arguments and reads CONTROL file
         content. Apply default values for non mentioned arguments.
 
@@ -38,6 +82,6 @@
             Contains the commandline arguments from script/program call.
 
-        c: instance of class Control
-            Contains all necessary information of a control file. The parameters
+        c: instance of class ControlFile
+            Contains all necessary information of a CONTROL file. The parameters
             are: DAY1, DAY2, DTIME, MAXSTEP, TYPE, TIME, STEP, CLASS, STREAM,
             NUMBER, EXPVER, GRID, LEFT, LOWER, UPPER, RIGHT, LEVEL, LEVELIST,
@@ -62,5 +106,5 @@
                         help="# of days to be retrieved at once")
 
-    # some arguments that override the default in the control file
+    # some arguments that override the default in the CONTROL file
     parser.add_argument("--basetime", dest="basetime",
                         help="base such as 00/12 (for half day retrievals)")
@@ -96,5 +140,5 @@
     parser.add_argument("--controlfile", dest="controlfile",
                         default='CONTROL.temp',
-                        help="file with control parameters")
+                        help="file with CONTROL parameters")
     parser.add_argument("--debug", dest="debug", default=0,
                         help="Debug mode - leave temporary files intact")
@@ -102,13 +146,13 @@
     args = parser.parse_args()
 
-    # create instance of Control for specified controlfile
+    # create instance of ControlFile for specified controlfile
     # and assign the parameters (and default values if necessary)
     try:
-        c = Control.Control(args.controlfile)
+        c = ControlFile(args.controlfile)
     except IOError:
         try:
-            c = Control.Control(localpythonpath + args.controlfile)
+            c = ControlFile(localpythonpath + args.controlfile)
         except:
-            print('Could not read control file "' + args.controlfile + '"')
+            print('Could not read CONTROL file "' + args.controlfile + '"')
             print('Either it does not exist or its syntax is wrong.')
             print('Try "' + sys.argv[0].split('/')[-1] +
@@ -119,10 +163,10 @@
     if  args.start_date is None and getattr(c, 'start_date') is None:
         print('start_date specified neither in command line nor \
-               in control file ' + args.controlfile)
+               in CONTROL file ' + args.controlfile)
         print('Try "' + sys.argv[0].split('/')[-1] +
               ' -h" to print usage information')
         exit(1)
 
-    # save all existing command line parameter to the Control instance
+    # save all existing command line parameter to the ControlFile instance
     # if parameter is not specified through the command line or CONTROL file
     # set default values
@@ -199,9 +243,9 @@
     @Description:
         Remove all files from intermediate directory
-        (inputdir from control file).
-
-    @Input:
-        c: instance of class Control
-            Contains all the parameters of control files, which are e.g.:
+        (inputdir from CONTROL file).
+
+    @Input:
+        c: instance of class ControlFile
+            Contains all the parameters of CONTROL file, which are e.g.:
             DAY1(start_date), DAY2(end_date), DTIME, MAXSTEP, TYPE, TIME,
             STEP, CLASS(marsclass), STREAM, NUMBER, EXPVER, GRID, LEFT,
@@ -240,6 +284,6 @@
 
     @Input:
-        c: instance of class Control
-            Contains all the parameters of control files, which are e.g.:
+        c: instance of class ControlFile
+            Contains all the parameters of CONTROL file, which are e.g.:
             DAY1(start_date), DAY2(end_date), DTIME, MAXSTEP, TYPE, TIME,
             STEP, CLASS(marsclass), STREAM, NUMBER, EXPVER, GRID, LEFT,
@@ -290,6 +334,6 @@
 
     @Input:
-        c: instance of class Control
-            Contains all the parameters of control files, which are e.g.:
+        c: instance of class ControlFile
+            Contains all the parameters of CONTROL file, which are e.g.:
             DAY1(start_date), DAY2(end_date), DTIME, MAXSTEP, TYPE, TIME,
             STEP, CLASS(marsclass), STREAM, NUMBER, EXPVER, GRID, LEFT,
@@ -357,5 +401,4 @@
             See example in description above.
     '''
-
     pools = map(tuple, args) * kwds.get('repeat', 1)
     result = [[]]
@@ -371,7 +414,6 @@
     '''
     @Description:
-        Removes the file which name is passed to the function if
-        it exists. The function does not fail if the file does not
-        exist.
+        If "filename" exists , it is removed.
+        The function does not fail if the file does not exist.
 
     @Input:
@@ -426,5 +468,5 @@
     @Input:
         pars: string
-            Addpar argument from control file in the format of
+            Addpar argument from CONTROL file in the format of
             parameter names instead of ids. The parameter short
             names are sepearted with "/" and they are passed as
@@ -438,5 +480,5 @@
     @Return:
         ipar: list of integer
-            List of addpar parameters from control file transformed to
+            List of addpar parameters from CONTROL file transformed to
             parameter ids in the format of integer.
     '''
@@ -455,7 +497,19 @@
     return ipar
 
-def getListAsString(listobj):
-    '''
-    @Description:
-    '''
-    return ", ".join( str(l) for l in listobj)
+def getListAsString(listObj):
+    '''
+    @Description:
+        Converts a list of arbitrary content into a single string.
+
+    @Input:
+        listObj: list
+            A list with arbitrary content.
+
+    @Return:
+        strOfList: string
+            The content of the list as a single string.
+    '''
+
+    strOfList = ", ".join( str(l) for l in listObj)
+
+    return strOfList
Index: python/UIOFiles.py
===================================================================
--- python/UIOFiles.py	(revision None)
+++ python/UIOFiles.py	(revision 991df6ad0a703d97e1e192a0a6106e1d9ba47e8e)
@@ -3,38 +3,46 @@
 #************************************************************************
 # TODO AP
-#AP
 # - checken welche regelmässigen methoden auf diese Files noch angewendet werden
 # und dann hier implementieren
-# - add description of file!
+# cleanup hier rein
 #************************************************************************
-"""
-@Author: Anne Fouilloux (University of Oslo)
+#*******************************************************************************
+# @Author: Anne Fouilloux (University of Oslo)
+#
+# @Date: October 2014
+#
+# @Change History:
+#
+#    November 2015 - Leopold Haimberger (University of Vienna):
+#        - modified method listFiles to work with glob instead of listdir
+#        - added pattern search in method listFiles
+#
+#    February 2018 - Anne Philipp (University of Vienna):
+#        - applied PEP8 style guide
+#        - added documentation
+#        - optimisation of method listFiles since it didn't work correctly
+#          for sub directories
+#        - additional speed up of method listFiles
+#        - modified the class so that it is initiated with a pattern instead
+#          of suffixes. Gives more precision in selection of files.
+#
+# @License:
+#    (C) Copyright 2014-2018.
+#
+#    This software is licensed under the terms of the Apache Licence Version 2.0
+#    which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
+#
+# @Class Decription:
+#    The class is for file manipulation. It is initiated with a regular
+#    expression pattern for this instance and can produce a list of Files
+#    from the given file pattern. These files can be deleted.
+#
+# @Class Content:
+#    - __init__
+#    - listFiles
+#    - deleteFiles
+#
+#*******************************************************************************
 
-@Date: October 2014
-
-@ChangeHistory:
-    November 2015 - Leopold Haimberger (University of Vienna):
-        - modified method listFiles to work with glob instead of listdir
-        - added pattern search in method listFiles
-
-    February 2018 - Anne Philipp (University of Vienna):
-        - applied PEP8 style guide
-        - added documentation
-        - optimisation of method listFiles since it didn't work correctly
-          for sub directories
-        - additional speed up of method listFiles
-
-@License:
-    (C) Copyright 2014-2018.
-
-    This software is licensed under the terms of the Apache Licence Version 2.0
-    which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
-
-@Requirements:
-    A standard python 2.6 or 2.7 installation
-
-@Description:
-    ...
-"""
 # ------------------------------------------------------------------------------
 # MODULES
@@ -44,12 +52,17 @@
 import fnmatch
 import time
+
+# software specific module from flex_extract
 import profiling
+from Tools import silentremove
+
 # ------------------------------------------------------------------------------
 # CLASS
 # ------------------------------------------------------------------------------
+
 class UIOFiles:
     '''
     Class to manipulate files. At initialisation it has the attribute
-    suffix which stores a list of suffixes of the files associated
+    pattern which stores a regular expression pattern for the files associated
     with the instance of the class.
     '''
@@ -57,9 +70,8 @@
     # CLASS FUNCTIONS
     # --------------------------------------------------------------------------
-    def __init__(self, suffix):
+    def __init__(self, pattern):
         '''
         @Description:
-            Assignes the suffixes of the files which should be
-            associated with the instance of the class.
+            Assignes a specific pattern for these files.
 
         @Input:
@@ -67,7 +79,6 @@
                 Description see class documentation.
 
-            suffix: list of strings
-                The types of files which should be manipulated such as
-                ['grib', 'grb', 'grib1', 'grib2', 'grb1', 'grb2']
+            pattern: string
+                Regular expression pattern. For example: '*.grb'
 
         @Return:
@@ -75,15 +86,14 @@
         '''
 
-        self.suffix = suffix
+        self.pattern = pattern
 
         return
 
     #@profiling.timefn
-    def listFiles(self, path, pattern, callid=0):
+    def listFiles(self, path, callid=0):
         '''
         @Description:
             Lists all files in the directory with the matching
-            regular expression pattern. The suffixes are already stored
-            in a list attribute "suffix".
+            regular expression pattern.
 
         @Input:
@@ -93,8 +103,4 @@
             path: string
                 Directory where to list the files.
-
-            pattern: string
-                Regular expression pattern. For example:
-                '*OG_acc_SL*.'+c.ppid+'.*'
 
             callid: integer
@@ -115,8 +121,7 @@
 
         # get the file list of the path if its not a directory and
-        # if it contains one of the suffixes
+        # if it contains the pattern
         self.files.extend([os.path.join(path, k) for k in os.listdir(path)
-                           if fnmatch.fnmatch(k, pattern) and
-                           os.path.splitext(k)[-1] in self.suffix])
+                           if fnmatch.fnmatch(k, self.pattern)])
 
         # find possible sub-directories in the path
@@ -127,5 +132,23 @@
         if subdirs:
             for subdir in subdirs:
-                self.listFiles(os.path.join(path, subdir), pattern, callid=1)
+                self.listFiles(os.path.join(path, subdir), callid=1)
 
         return
+
+    def deleteFiles(self):
+        '''
+        @Description:
+            Deletes the files.
+
+        @Input:
+            self: instance of UIOFiles
+                Description see class documentation.
+
+        @Return:
+            <nothing>
+        '''
+
+        for f in self.files:
+            silentremove(f)
+
+        return
Index: python/compilejob.ksh
===================================================================
--- python/compilejob.ksh	(revision efdb01a8ac2d5cef85c651177aa18ac69dd660db)
+++ python/compilejob.ksh	(revision 991df6ad0a703d97e1e192a0a6106e1d9ba47e8e)
@@ -5,5 +5,5 @@
 # start with sbatch NAME_OF_THIS_FILE directly on machine
 
-#SBATCH --workdir=/scratch/ms/at/km4a
+#SBATCH --workdir=/scratch/ms/spatlh00/lh0
 #SBATCH --qos=normal
 #SBATCH --job-name=flex_ecmwf
@@ -33,5 +33,5 @@
   module load grib_api/1.14.5
   module load emos/437-r64
-export FLEXPART_ROOT_SCRIPTS=${HOME}
+export FLEXPART_ROOT_SCRIPTS=$HOME
 #  export ECMWFDATA=$FLEXPART_ROOT/ECMWFDATA$VERSION
 #  export PYTHONPATH=$ECMWFDATA/python
@@ -49,5 +49,5 @@
   export GROUP=`echo $HOME | awk -F / '{print $4}'`
   export SCRATCH=/scratch/ms/${GROUP}/${USER}
-export FLEXPART_ROOT_SCRIPTS=${HOME}
+export FLEXPART_ROOT_SCRIPTS=$HOME
 #  export ECMWFDATA=$FLEXPART_ROOT/ECMWFDATA$VERSION
 #  export PYTHONPATH=$ECMWFDATA/python
